/**
* The XMOJO Project 5
* Copyright  2003 XMOJO.org. All rights reserved.

* NO WARRANTY

* BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR
* THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN
* OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
* PROVIDE THE LIBRARY "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
* OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS
* TO THE QUALITY AND PERFORMANCE OF THE LIBRARY IS WITH YOU. SHOULD THE
* LIBRARY PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
* REPAIR OR CORRECTION.

* IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL
* ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR REDISTRIBUTE
* THE LIBRARY AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
* GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
* USE OR INABILITY TO USE THE LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF
* DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
* PARTIES OR A FAILURE OF THE LIBRARY TO OPERATE WITH ANY OTHER SOFTWARE),
* EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
* SUCH DAMAGES.
**/

package javax.management;


/**
 * Defines the management interface of an object of class MBeanServerDelegate.
 */
public abstract interface MBeanServerDelegateMBean
{
	/**
	 * Returns the JMX implementation name (the name of this product).
	 *
	 * @return The JMX implementation name is returned
	 */
	public String getImplementationName();

	/**
	 * Returns the JMX implementation vendor (the vendor of this product).
	 *
	 * @return The JMX implementation vendor is returned
	 */
	public String getImplementationVendor();

	/**
	 * Returns the JMX implementation version (the version of this product).
	 *
	 * @return The JMX implementation version is returned
	 */
	public String getImplementationVersion();

	/**
	 * Get the MBeanServer agent identification.
	 *
	 * @return The MBeanServer agent identification is returned
	 */
	public java.lang.String getMBeanServerId();

	/**
	 * Returns the full name of the JMX specification implemented by this product.
	 *
	 * @return The full name of the JMX specification implemented by
	 * 				this product is returned.
	 */
	public String getSpecificationName();

	/**
	 * Returns the vendor of the JMX specification implemented by this product.
	 *
	 * @return The vendor of the JMX specification implemented by
	 * 				this product is returned.
     */
	public String getSpecificationVendor();

	/**
	 * Returns the version of the JMX specification implemented by this product.
	 *
	 * @return The version of the JMX specification implemented by
	 * 				this product is returned
	 */
	public String getSpecificationVersion();
}